import { IApi } from '@mesg/api/lib/types';
import { ExecutionStreamOutputs } from '@mesg/api/lib/execution';
import { hash } from '@mesg/api/lib/types';
import { EventCreateOutputs } from '@mesg/api/lib/event';
declare type Options = {
    runnerHash?: hash;
    instanceHash?: hash;
    definition?: any;
    API?: IApi;
};
declare class Service {
    private API;
    private runnerHash;
    private instanceHash;
    private definition;
    private tasks;
    constructor(options?: Options);
    listenTask({ ...tasks }: Tasks): ExecutionStreamOutputs;
    emitEvent(event: string, data: EventData): EventCreateOutputs;
    private handleTaskData;
    private validateTaskNames;
}
interface Tasks {
    [task: string]: (inputs: TaskInputs) => TaskOutputs | Promise<TaskOutputs>;
}
interface TaskOutputs {
    [key: string]: any;
}
interface TaskInputs {
    [key: string]: any;
}
interface EventData {
    [key: string]: any;
}
export default Service;
export { Tasks, TaskInputs, };
